/***************************************************************************************************
LoadingOverlay - A flexible loading overlay jQuery plugin
    Author          : Gaspare Sganga
    Version         : 2.1.3
    License         : MIT
    Documentation   : https://gasparesganga.com/labs/jquery-loading-overlay/
***************************************************************************************************/
!function(e){"function"==typeof define&&define.amd?define(["jquery"],e):"object"==typeof module&&module.exports?e(require("jquery")):e(jQuery)}(function(e,s){"use strict";var a={background:"rgba(255, 255, 255, 0.8)",backgroundClass:"",image:"<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 1000 1000'><circle r='80' cx='500' cy='90'/><circle r='80' cx='500' cy='910'/><circle r='80' cx='90' cy='500'/><circle r='80' cx='910' cy='500'/><circle r='80' cx='212' cy='212'/><circle r='80' cx='788' cy='212'/><circle r='80' cx='212' cy='788'/><circle r='80' cx='788' cy='788'/></svg>",imageAnimation:"2000ms rotate_right",imageAutoResize:!0,imageResizeFactor:1,imageColor:"#202020",imageClass:"",imageOrder:1,fontawesome:"",fontawesomeAnimation:"",fontawesomeAutoResize:!0,fontawesomeResizeFactor:1,fontawesomeColor:"#202020",fontawesomeOrder:2,custom:"",customAnimation:"",customAutoResize:!0,customResizeFactor:1,customOrder:3,text:"",textAnimation:"",textAutoResize:!0,textResizeFactor:.5,textColor:"#202020",textClass:"",textOrder:4,progress:!1,progressAutoResize:!0,progressResizeFactor:.25,progressColor:"#a0a0a0",progressClass:"",progressOrder:5,progressFixedPosition:"",progressSpeed:200,progressMin:0,progressMax:100,size:50,maxSize:120,minSize:20,direction:"column",fade:!0,resizeInterval:50,zIndex:2147483647},t={overlay:{"box-sizing":"border-box",position:"relative",display:"flex","flex-wrap":"nowrap","align-items":"center","justify-content":"space-around"},element:{"box-sizing":"border-box",overflow:"visible",flex:"0 0 auto",display:"flex","justify-content":"center","align-items":"center"},element_svg:{width:"100%",height:"100%"},progress_fixed:{position:"absolute",left:"0",width:"100%"},progress_wrapper:{position:"absolute",top:"0",left:"0",width:"100%",height:"100%"},progress_bar:{position:"absolute",left:"0"}},o={count:0,container:s,settings:s,wholePage:s,resizeIntervalId:s,text:s,progress:s},r={animations:["rotate_right","rotate_left","fadein","pulse"],progressPosition:["top","bottom"]},i={animations:{name:"rotate_right",time:"2000ms"},fade:[400,200]};function n(s,a){s=e(s),a.size=y(a.size),a.maxSize=parseInt(a.maxSize,10)||0,a.minSize=parseInt(a.minSize,10)||0,a.resizeInterval=parseInt(a.resizeInterval,10)||0;var r=s.data("loadingoverlay"),n=f(r);if(!1===n){if((n=e.extend({},o)).container=s,n.wholePage=s.is("body"),r=e("<div>",{class:"loadingoverlay"}).css(t.overlay).css("flex-direction","row"===a.direction.toLowerCase()?"row":"column"),a.backgroundClass?r.addClass(a.backgroundClass):r.css("background",a.background),n.wholePage&&r.css({position:"fixed",top:0,left:0,width:"100%",height:"100%"}),void 0!==a.zIndex&&r.css("z-index",a.zIndex),a.image){e.isArray(a.imageColor)?0===a.imageColor.length?a.imageColor=!1:1===a.imageColor.length?a.imageColor={fill:a.imageColor[0]}:a.imageColor={fill:a.imageColor[0],stroke:a.imageColor[1]}:a.imageColor&&(a.imageColor={fill:a.imageColor});var l=p(r,a.imageOrder,a.imageAutoResize,a.imageResizeFactor,a.imageAnimation);"<svg"===a.image.slice(0,4).toLowerCase()&&"</svg>"===a.image.slice(-6).toLowerCase()?(l.append(a.image),l.children().css(t.element_svg),!a.imageClass&&a.imageColor&&l.find("*").css(a.imageColor)):".svg"===a.image.slice(-4).toLowerCase()||"data:image/svg"===a.image.slice(0,14).toLowerCase()?l.load(a.image,function(){l.children().css(t.element_svg),!a.imageClass&&a.imageColor&&l.find("*").css(a.imageColor)}):l.css({"background-image":"url("+a.image+")","background-position":"center","background-repeat":"no-repeat","background-size":"cover"}),a.imageClass&&l.addClass(a.imageClass)}if(a.fontawesome){l=p(r,a.fontawesomeOrder,a.fontawesomeAutoResize,a.fontawesomeResizeFactor,a.fontawesomeAnimation).addClass("loadingoverlay_fa");e("<div>",{class:a.fontawesome}).appendTo(l),a.fontawesomeColor&&l.css("color",a.fontawesomeColor)}if(a.custom)l=p(r,a.customOrder,a.customAutoResize,a.customResizeFactor,a.customAnimation).append(a.custom);if(a.text&&(n.text=p(r,a.textOrder,a.textAutoResize,a.textResizeFactor,a.textAnimation).addClass("loadingoverlay_text").text(a.text),a.textClass?n.text.addClass(a.textClass):a.textColor&&n.text.css("color",a.textColor)),a.progress){l=p(r,a.progressOrder,a.progressAutoResize,a.progressResizeFactor,!1).addClass("loadingoverlay_progress");var g=e("<div>").css(t.progress_wrapper).appendTo(l);n.progress={bar:e("<div>").css(t.progress_bar).appendTo(g),fixed:!1,margin:0,min:parseFloat(a.progressMin),max:parseFloat(a.progressMax),speed:parseInt(a.progressSpeed,10)};var d=(a.progressFixedPosition+"").replace(/\s\s+/g," ").toLowerCase().split(" ");2===d.length&&x(d[0])?(n.progress.fixed=d[0],n.progress.margin=y(d[1])):2===d.length&&x(d[1])?(n.progress.fixed=d[1],n.progress.margin=y(d[0])):1===d.length&&x(d[0])&&(n.progress.fixed=d[0],n.progress.margin=0),"top"===n.progress.fixed?l.css(t.progress_fixed).css("top",n.progress.margin?n.progress.margin.value+(n.progress.margin.fixed?n.progress.margin.units:"%"):0):"bottom"===n.progress.fixed&&l.css(t.progress_fixed).css("top","auto"),a.progressClass?n.progress.bar.addClass(a.progressClass):a.progressColor&&n.progress.bar.css("background",a.progressColor)}a.fade?!0===a.fade?a.fade=i.fade:"string"==typeof a.fade||"number"==typeof a.fade?a.fade=[a.fade,a.fade]:e.isArray(a.fade)&&a.fade.length<2&&(a.fade=[a.fade[0],a.fade[0]]):a.fade=[0,0],a.fade=[parseInt(a.fade[0],10),parseInt(a.fade[1],10)],n.settings=a,r.data("loadingoverlay_data",n),s.data("loadingoverlay",r),r.fadeTo(0,.01).appendTo("body"),m(s,!0),a.resizeInterval>0&&(n.resizeIntervalId=setInterval(function(){m(s,!1)},a.resizeInterval)),r.fadeTo(a.fade[0],1)}n.count++}function l(s,a){var t=(s=e(s)).data("loadingoverlay"),o=f(t);!1!==o&&(o.count--,(a||o.count<=0)&&(o.resizeIntervalId&&clearInterval(o.resizeIntervalId),t.fadeOut(o.settings.fade[1],function(){e(this).remove()}),s.removeData("loadingoverlay")))}function g(s){m(e(s),!0)}function d(s,a){var t=f((s=e(s)).data("loadingoverlay"));!1!==t&&t.text&&(!1===a?t.text.hide():t.text.show().text(a))}function c(s,a){var t=f((s=e(s)).data("loadingoverlay"));if(!1!==t&&t.progress)if(!1===a)t.progress.bar.hide();else{var o=100*((parseFloat(a)||0)-t.progress.min)/(t.progress.max-t.progress.min);o<0&&(o=0),o>100&&(o=100),t.progress.bar.show().animate({width:o+"%"},t.progress.speed)}}function m(s,a){var t=s.data("loadingoverlay"),o=f(t);if(!1!==o){if(!o.wholePage){var r="fixed"===s.css("position"),i=r?s[0].getBoundingClientRect():s.offset();t.css({position:r?"fixed":"absolute",top:i.top+parseInt(s.css("border-top-width"),10),left:i.left+parseInt(s.css("border-left-width"),10),width:s.innerWidth(),height:s.innerHeight()})}if(o.settings.size){var n=o.wholePage?e(window):s,l=o.settings.size.value;o.settings.size.fixed||(l=Math.min(n.innerWidth(),n.innerHeight())*l/100,o.settings.maxSize&&l>o.settings.maxSize&&(l=o.settings.maxSize),o.settings.minSize&&l<o.settings.minSize&&(l=o.settings.minSize)),t.children(".loadingoverlay_element").each(function(){var s=e(this);if(a||s.data("loadingoverlay_autoresize")){var t=s.data("loadingoverlay_resizefactor");s.hasClass("loadingoverlay_fa")||s.hasClass("loadingoverlay_text")?s.css("font-size",l*t+o.settings.size.units):s.hasClass("loadingoverlay_progress")?(o.progress.bar.css("height",l*t+o.settings.size.units),o.progress.fixed?"bottom"===o.progress.fixed&&s.css("bottom",o.progress.margin?o.progress.margin.value+(o.progress.margin.fixed?o.progress.margin.units:"%"):0).css("bottom","+="+l*t+o.settings.size.units):o.progress.bar.css("top",s.position().top).css("top","-="+l*t*.5+o.settings.size.units)):s.css({width:l*t+o.settings.size.units,height:l*t+o.settings.size.units})}})}}}function f(a){var t=void 0===a?s:a.data("loadingoverlay_data");return void 0===t?(e(".loadingoverlay").each(function(){var s=e(this);document.body.contains(s.data("loadingoverlay_data").container[0])||s.remove()}),!1):t}function p(s,a,o,r,n){var l=e("<div>",{class:"loadingoverlay_element",css:{order:a}}).css(t.element).data({loadingoverlay_autoresize:o,loadingoverlay_resizefactor:r}).appendTo(s);if(!0===n&&(n=i.animations.time+" "+i.animations.name),"string"==typeof n){var g,d,c=n.replace(/\s\s+/g," ").toLowerCase().split(" ");2===c.length&&u(c[0])&&v(c[1])?(g=c[1],d=c[0]):2===c.length&&u(c[1])&&v(c[0])?(g=c[0],d=c[1]):1===c.length&&u(c[0])?(g=i.animations.name,d=c[0]):1===c.length&&v(c[0])&&(g=c[0],d=i.animations.time),l.css({"animation-name":"loadingoverlay_animation__"+g,"animation-duration":d,"animation-timing-function":"linear","animation-iteration-count":"infinite"})}return l}function u(e){return!isNaN(parseFloat(e))&&("s"===e.slice(-1)||"ms"===e.slice(-2))}function v(e){return r.animations.indexOf(e)>-1}function x(e){return r.progressPosition.indexOf(e)>-1}function y(e){return!(!e||e<0)&&("string"==typeof e&&["vmin","vmax"].indexOf(e.slice(-4))>-1?{fixed:!0,units:e.slice(-4),value:e.slice(0,-4)}:"string"==typeof e&&["rem"].indexOf(e.slice(-3))>-1?{fixed:!0,units:e.slice(-3),value:e.slice(0,-3)}:"string"==typeof e&&["px","em","cm","mm","in","pt","pc","vh","vw"].indexOf(e.slice(-2))>-1?{fixed:!0,units:e.slice(-2),value:e.slice(0,-2)}:{fixed:!1,units:"px",value:parseFloat(e)})}e.LoadingOverlaySetup=function(s){e.extend(!0,a,s)},e.LoadingOverlay=function(s,t){switch(s.toLowerCase()){case"show":n("body",e.extend(!0,{},a,t));break;case"hide":l("body",t);break;case"resize":g("body");break;case"text":d("body",t);break;case"progress":c("body",t)}},e.fn.LoadingOverlay=function(s,t){switch(s.toLowerCase()){case"show":var o=e.extend(!0,{},a,t);return this.each(function(){n(this,o)});case"hide":return this.each(function(){l(this,t)});case"resize":return this.each(function(){g(this)});case"text":return this.each(function(){d(this,t)});case"progress":return this.each(function(){c(this,t)})}},e(function(){e("head").append(["<style>","@-webkit-keyframes loadingoverlay_animation__rotate_right {","to {","-webkit-transform : rotate(360deg);","transform : rotate(360deg);","}","}","@keyframes loadingoverlay_animation__rotate_right {","to {","-webkit-transform : rotate(360deg);","transform : rotate(360deg);","}","}","@-webkit-keyframes loadingoverlay_animation__rotate_left {","to {","-webkit-transform : rotate(-360deg);","transform : rotate(-360deg);","}","}","@keyframes loadingoverlay_animation__rotate_left {","to {","-webkit-transform : rotate(-360deg);","transform : rotate(-360deg);","}","}","@-webkit-keyframes loadingoverlay_animation__fadein {","0% {","opacity   : 0;","-webkit-transform : scale(0.1, 0.1);","transform : scale(0.1, 0.1);","}","50% {","opacity   : 1;","}","100% {","opacity   : 0;","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","}","@keyframes loadingoverlay_animation__fadein {","0% {","opacity   : 0;","-webkit-transform : scale(0.1, 0.1);","transform : scale(0.1, 0.1);","}","50% {","opacity   : 1;","}","100% {","opacity   : 0;","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","}","@-webkit-keyframes loadingoverlay_animation__pulse {","0% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","50% {","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","100% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","}","@keyframes loadingoverlay_animation__pulse {","0% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","50% {","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","100% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","}","</style>"].join(" "))})});